local TGE = select(2,...)
TGE = LibStub("AceAddon-3.0"):NewAddon(TGE, "TotalGoldEarned", "AceConsole-3.0", "AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
TGE.version = GetAddOnMetadata("TotalGoldEarned", "Version")
local PLAYERNAME = UnitName("player")
local REALMNAME = GetRealmName()
TGE_TestVARIABLE = nil
local Addon_Opened = false
local savedDBDefaults = { --- Default the saved variables
	profile = {

	},
	global = {
		CurrentTotals = {
		}
	},
	factionrealm = {
		CurrentGold = {
		}
	},
}

TGE:RegisterChatCommand("TGE", "Open")
TGE:RegisterChatCommand("ClearTGE", "Clear")

function TGE:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function TGE:OnInitialize() --- On addon innitialized
	TGE.db = LibStub:GetLibrary("AceDB-3.0"):New("TotalGoldEarnedDB", savedDBDefaults, true)
end

function TGE:Open()

	local TotalGold = 0
	--[[for I,V in pairs(TGE.db.factionrealm) do
		TGE:Print(I,V)
	end]]

	for Server,gold in pairs(TGE.db.global) do
		--TGE:Print("Global Data: "..Server,gold)
		if type(gold) == "number" then
			TotalGold = TotalGold + gold
			--TGE:Print(gold)
		end
	end
	--print(TGE_TestVARIABLE)
	--TGE:Print("All Servers: "..TotalGold)

	if Addon_Opened == false then
		TGEframe = AceGUI:Create("Frame")
		TGEframe:SetTitle("Total Gold Earned")
		TGEframe:SetStatusText("Overall Earned Total: "..TotalGold.."g")
		TGEframe:EnableResize(false)
		TGEframe:SetWidth(350)
		TGEframe:SetHeight(400)
		TGEframe:SetCallback("OnClose", function(widget) AceGUI:Release(widget) Addon_Opened = false end)
		TGEframe:SetLayout("Fill")

		local TabbedGroups = AceGUI:Create("TabGroup")
		TabbedGroups:SetLayout("Flow")
		TabbedGroups:SetTabs({{text="Overall Earned", value=1},{text="Current Server Earned", value=2},{text="Current Overall Gold", value=3},{text="Current Server Gold", value=4}})
		TabbedGroups:SetCallback("OnGroupSelected", TGE_SelectGroup)
		TabbedGroups:SelectTab(1)
		TGEframe:AddChild(TabbedGroups)

		Addon_Opened = true

		--TGE:BuildScrollGroup(TGEframe)

	elseif Addon_Opened == true then

		Addon_Opened = false
		AceGUI:Release(TGEframe)
	end

end

function TGE:PLAYER_ENTERING_WORLD()

	--------------------------------------------EARNED------------------------------------------
	local CurrentCount = GetStatistic(919)
	--print(CurrentCount)

	local Gold,Silver,Copper = strsplit(" ", CurrentCount)

	if Gold ~= nil then Gold = TGE:SubRemoveSymbols(Gold) else Gold = 0 end
	if Silver ~= nil then Silver = TGE:SubRemoveSymbols(Silver) else Silver = 0 end
	if Copper ~= nil then Copper = TGE:SubRemoveSymbols(Copper) else Copper = 0 end

	local CTABLE = CopyTable(TGE.db.factionrealm) -- Current table
	local SCTABLE = CopyTable(TGE.db.global) -- Server Current Table

	if CTABLE[PLAYERNAME] == nil then TGE.db.factionrealm[PLAYERNAME] = 0; CTABLE[PLAYERNAME] = 0 end -- Default to 0 for both coppied table and solid table

	-- Get previous gold for further use down the line
	local PreviousPlayerGold = CTABLE[PLAYERNAME]
	------
	if CTABLE[PLAYERNAME] < Gold then
		TGE.db.factionrealm[PLAYERNAME] = Gold
	end

	--- Server Totals Calculations
	if SCTABLE[REALMNAME] == nil then TGE.db.global[REALMNAME] = 0; SCTABLE[REALMNAME] = 0 end -- default server value to 0

	local CurrentServerGold = SCTABLE[REALMNAME]
	local CurrentServerGoldMinusCurrentCount = (CurrentServerGold - PreviousPlayerGold)
	local CurrentServerGoldPlusCurrentGold = (CurrentServerGoldMinusCurrentCount + Gold)

	TGE_TestVARIABLE = CurrentServerGold

	SCTABLE[REALMNAME] = CurrentServerGoldPlusCurrentGold
	TGE.db.global[REALMNAME] = CurrentServerGoldPlusCurrentGold

	--------------------------------- CURRENT -----------------------------------------------------------------------
	local CurrentHeldGold = floor(GetMoney()/10000)

	local CGTABLE = CopyTable(TGE.db.factionrealm.CurrentGold) -- Current gold table
	local SCGTABLE = CopyTable(TGE.db.global.CurrentTotals) -- Current Server gold table

	if CGTABLE[PLAYERNAME] == nil then TGE.db.factionrealm.CurrentGold[PLAYERNAME] = 0; CGTABLE[PLAYERNAME] = 0; end -- Default server to 0

	local PreviousCurrentGold = CGTABLE[PLAYERNAME]

	TGE.db.factionrealm.CurrentGold[PLAYERNAME] = CurrentHeldGold

	--- server current
	if SCGTABLE[REALMNAME] == nil then TGE.db.global.CurrentTotals[REALMNAME] = 0; SCTABLE[REALMNAME] = 0 end -- default server to 0

	local CurrentServerCurrentGold = SCGTABLE[REALMNAME]
	local CurrentServerCurrentGoldMinusCurrentCount = (CurrentServerCurrentGold - PreviousCurrentGold)
	local CurrentServerCurrentGoldPlusCurrentGold = (CurrentServerCurrentGoldMinusCurrentCount + CurrentHeldGold)

	SCGTABLE[REALMNAME] = CurrentServerCurrentGoldPlusCurrentGold
	TGE.db.global.CurrentTotals[REALMNAME] = CurrentServerCurrentGoldPlusCurrentGold

end

function TGE:SubRemoveSymbols(String)
	local String = String -- make a solid connection
	local Void -- Nothing!
	local length = (string.len(String) - 1) -- reduce length of string so it shows the whole string text
	String = string.sub(String,0,length) -- Sub the string by length
	String = strsplit("|", String) -- Split off the icon stuff
	String = tonumber(String) -- convert to string for later use
	if String == nil then String = 0 end
	return String
end

function TGE:Clear()
	wipe(TGE.db.factionrealm)
	wipe(TGE.db.global[REALMNAME])
	TGE:Print("All data has been cleared for current server")
end

function TGE:BuildOverallEarned(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextServer = AceGUI:Create("Label")
	HeaderTextServer:SetText("Servers")
	HeaderTextServer:SetRelativeWidth(0.5)
	HeaderTextServer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextServer)

	local HeaderTextGold = AceGUI:Create("Label")
	HeaderTextGold:SetText("Gold")
	HeaderTextGold:SetRelativeWidth(0.5)
	HeaderTextGold:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextGold)

	TGE:BuildOverallEarnedServerList(ScrollFrame)
end

function TGE:BuildOverallEarnedServerList(container)
	for Server, Gold in pairs(TGE.db.global) do
		--TGE:Print(Server, Gold)
		if Server ~= "CurrentTotals" then
			local HeaderFrame = AceGUI:Create("SimpleGroup")
			HeaderFrame:SetHeight(5)
			HeaderFrame:SetFullWidth()
			HeaderFrame:SetLayout("Flow")
			container:AddChild(HeaderFrame)

			local HeaderTextServer = AceGUI:Create("Label")
			HeaderTextServer:SetText(Server)
			HeaderTextServer:SetRelativeWidth(0.5)
			HeaderTextServer:SetFont("DEFAULT", 14, "OUTLINE")
			container:AddChild(HeaderTextServer)

			local HeaderTextGold = AceGUI:Create("Label")
			HeaderTextGold:SetText(Gold)
			HeaderTextGold:SetRelativeWidth(0.5)
			HeaderTextGold:SetFont("DEFAULT", 14, "OUTLINE")
			container:AddChild(HeaderTextGold)
		else
			--Do nothing
		end
	end
end

function TGE:BuildCurrentServerEarnedList(container)
	for Toon, Gold in pairs(TGE.db.factionrealm) do
		if Toon ~= "CurrentGold" then
			--TGE:Print(Toon, Gold)
			local HeaderFrame = AceGUI:Create("SimpleGroup")
			HeaderFrame:SetHeight(5)
			HeaderFrame:SetFullWidth()
			HeaderFrame:SetLayout("Flow")
			container:AddChild(HeaderFrame)

			local TextToon = AceGUI:Create("Label")
			TextToon:SetText(Toon)
			TextToon:SetRelativeWidth(0.5)
			TextToon:SetFont("DEFAULT", 14, "OUTLINE")
			container:AddChild(TextToon)

			local TextGold = AceGUI:Create("Label")
			TextGold:SetText(Gold)
			TextGold:SetRelativeWidth(0.5)
			TextGold:SetFont("DEFAULT", 14, "OUTLINE")
			container:AddChild(TextGold)
		else
			--Do nothing
		end
	end
end

function TGE:BuildCurrentServerEarned(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextServer = AceGUI:Create("Label")
	HeaderTextServer:SetText("Server")
	HeaderTextServer:SetRelativeWidth(0.5)
	HeaderTextServer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextServer)

	local HeaderTextGold = AceGUI:Create("Label")
	HeaderTextGold:SetText("Gold")
	HeaderTextGold:SetRelativeWidth(0.5)
	HeaderTextGold:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextGold)

	TGE:BuildCurrentServerEarnedList(ScrollFrame)

end

function TGE:BuildCurrentOverallGold(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextServer = AceGUI:Create("Label")
	HeaderTextServer:SetText("Server")
	HeaderTextServer:SetRelativeWidth(0.5)
	HeaderTextServer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextServer)

	local HeaderTextGold = AceGUI:Create("Label")
	HeaderTextGold:SetText("Gold")
	HeaderTextGold:SetRelativeWidth(0.5)
	HeaderTextGold:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextGold)

	TGE:BuildCurrentOverallGoldList(ScrollFrame)

end

function TGE:BuildCurrentOverallGoldList(container)
	for Server, Gold in pairs(TGE.db.global.CurrentTotals) do
		--TGE:Print(Toon, Gold)
		local HeaderFrame = AceGUI:Create("SimpleGroup")
		HeaderFrame:SetHeight(5)
		HeaderFrame:SetFullWidth()
		HeaderFrame:SetLayout("Flow")
		container:AddChild(HeaderFrame)

		local TextToon = AceGUI:Create("Label")
		TextToon:SetText(Server)
		TextToon:SetRelativeWidth(0.5)
		TextToon:SetFont("DEFAULT", 14, "OUTLINE")
		container:AddChild(TextToon)

		local TextGold = AceGUI:Create("Label")
		TextGold:SetText(Gold)
		TextGold:SetRelativeWidth(0.5)
		TextGold:SetFont("DEFAULT", 14, "OUTLINE")
		container:AddChild(TextGold)
	end
end

function TGE:BuildCurrentServerGold(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextServer = AceGUI:Create("Label")
	HeaderTextServer:SetText("Toon")
	HeaderTextServer:SetRelativeWidth(0.5)
	HeaderTextServer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextServer)

	local HeaderTextGold = AceGUI:Create("Label")
	HeaderTextGold:SetText("Gold")
	HeaderTextGold:SetRelativeWidth(0.5)
	HeaderTextGold:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextGold)

	TGE:BuildCurrentServerGoldList(ScrollFrame)

end

function TGE:BuildCurrentServerGoldList(container)
	for Toon, Gold in pairs(TGE.db.factionrealm.CurrentGold) do
		--TGE:Print(Toon, Gold)
		local HeaderFrame = AceGUI:Create("SimpleGroup")
		HeaderFrame:SetHeight(5)
		HeaderFrame:SetFullWidth()
		HeaderFrame:SetLayout("Flow")
		container:AddChild(HeaderFrame)

		local TextToon = AceGUI:Create("Label")
		TextToon:SetText(Toon)
		TextToon:SetRelativeWidth(0.5)
		TextToon:SetFont("DEFAULT", 14, "OUTLINE")
		container:AddChild(TextToon)

		local TextGold = AceGUI:Create("Label")
		TextGold:SetText(Gold)
		TextGold:SetRelativeWidth(0.5)
		TextGold:SetFont("DEFAULT", 14, "OUTLINE")
		container:AddChild(TextGold)
	end
end

function TGE_SelectGroup(container, event, group)
	container:ReleaseChildren()
	if group == 1 then
		TGE:BuildOverallEarned(container)
	elseif group == 2 then
		TGE:BuildCurrentServerEarned(container)
	elseif group == 3 then
		TGE:BuildCurrentOverallGold(container)
	elseif group == 4 then
		TGE:BuildCurrentServerGold(container)
	else
		return
	end
end
